package com.typ.myframework.connectionpool;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

public class ConnectionFactoryImpl implements ConnectionFactory {
	private List<Connection> connections = new ArrayList<Connection>();
	/**
	 * ¼connections±ӦǷʹУ
	 * 0  1æ
	 */
	private int[] busy = null;
	
	private int maxConnCount = 10;

	//ݿurl
	private String url = "";
	
	public ConnectionFactoryImpl() {
		init();
	}	
	/* ʼݿϢ */
	private void init() {	
		ConnectionInfo connMesg = new ConnectionInfo();		
		maxConnCount = Integer.parseInt(connMesg.getConfigMap().get("maxConnCount"));	
		url = connMesg.getConfigMap().get("url");
		busy = new int[maxConnCount];
		try {
			Class.forName(connMesg.getConfigMap().get("driverClassName"));			
			for(int i = 0;i < maxConnCount;i++) {			
				connections.add(DriverManager.getConnection(url));		 		
			}
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	/**
	 * ڳóһеӣأûпеnewµķ
	 * @return 
	 */
	@Override
	public synchronized Connection getConnection() {
		for(int i = 0;i < maxConnCount;i++) {
			if (busy[i] == 0) {
				busy[i] = 1;
				return  connections.get(i);
			}
		}
		Connection conn = null;
		try {
			conn = DriverManager.getConnection(url);
		} catch (SQLException e) {
			e.printStackTrace();
		} 
		return conn;
	}	
	/**
	 * жϴݹǲӳеӣǵİ֮Ӧ״̬Ϊ  У
	 * ӳеӣֱӹر
	 * @param conn
	 */
	@Override
	public void close(Connection conn) {
		
		if(conn == null)return;
		
		Connection connection = null;
		for(int i = 0;i < maxConnCount;i++) {
			connection = connections.get(i);
			if (connection == conn) {
				busy[i] = 0;
				return;
			}
		}

		try {
			conn.close();
		} catch (SQLException e) {			
			e.printStackTrace();
		}
	}
	@Override
	public List<Connection> getConnections() {
		return connections;
	}		
}
