package com.typ.myframework.connectionpool;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;


public class ConnectionInfo {
	
	private Map<String,String> configMap = new HashMap<String,String>(); 	
	private String configFileName = "jdbc.properties";
	
	public ConnectionInfo() {
		try {
			loadConfig();
		} catch (ReadJDBCPropertiesException e) {
			e.printStackTrace();
		}
	}
	
	public Map<String,String> loadConfig() throws ReadJDBCPropertiesException {
		Properties properties = new Properties();	
		try {
			properties.load(this.getClass().getClassLoader().getResourceAsStream(configFileName));			
			String driverClassName = properties.getProperty("driverClassName");
			String strMaxConnCount = properties.getProperty("maxConnectionCount");
			int maxConnCount = Integer.parseInt(strMaxConnCount);
			String username = properties.getProperty("username");
			String password = properties.getProperty("password");
			String url = properties.getProperty("url") 
								+ "?user=" + username + "&password=" + password;	
			configMap.put("url", url);
			configMap.put("driverClassName", driverClassName);
			configMap.put("maxConnCount", strMaxConnCount);
			configMap.put("username", username);
			configMap.put("password", password);
			
		} catch (NumberFormatException e) {
			throw new ReadJDBCPropertiesException("ڶȡļjdbc.propertiesmaxConnectionCountʱļ");
		} catch (IOException e) {			
			throw new ReadJDBCPropertiesException("ڶȡļjdbc.propertiesʱļ");
		}
		return configMap;
	}

	public Map<String, String> getConfigMap() {
		return configMap;
	}

	public void setConfigMap(Map<String, String> configMap) {
		this.configMap = configMap;
	}

	public String getConfigFileName() {
		return configFileName;
	}

	public void setConfigFileName(String configFileName) {
		this.configFileName = configFileName;
	}
}
