package com.typ.myframework.hibernate;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.dom4j.Attribute;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

import com.typ.myframework.Initable;


public class XmlSqlContextBuilder implements Initable {		
	
	private Map<String,SqlInfo> sqlInfos = new HashMap<String,SqlInfo>();
	private  String fname;
	
	public XmlSqlContextBuilder() {
		this("sqls.xml");
	}

	public XmlSqlContextBuilder(String fileName) {
		this.fname = fileName;
		init();
	}
	
	@Override
	public void init() {
		Element root = read(fname).getRootElement();		
		List<Element> sqls = root.elements();
		for(int i = 0;i < sqls.size();i++) {			
			try {
				fillToList(sqls.get(i),i);
			} catch (SqlsXmlReadException e) {
				e.printStackTrace();
			}
		}
	}
	
	@Override
	public Map<String,SqlInfo> getMap() {
		return sqlInfos;
	}

	@Override
	public void reload() {
		init();
	}		
	
	private void fillToList(Element sql,int i) throws SqlsXmlReadException {		
	
		if (sql.attribute("id") == null) {
			throw new SqlsXmlReadException("" + i +"sq" +
					"lԪصidΪ");
		} 		
		if(sql.element("sql-name") == null) {
			throw new SqlsXmlReadException("Ҳ" + i +"sqlԪصӽڵ<sql_name>");
		}	
		
		String sqlTypeValue = "sql";
		String idValue = sql.attribute("id").getText();
		String sqlNameValue = sql.element("sql-name").getText();
		
		if (sqlNameValue.trim() == "") {
			throw new SqlsXmlReadException("" + i +"sqlԪصӽڵ<sql-name>ֵΪ");
		}
		if (sql.element("sql-type") != null) {
			sqlTypeValue = sql.element("sql-type").getText();
		}			

		if (sqlInfos.containsKey(idValue)) {		
			throw new SqlsXmlReadException("ͬid,ÿsqlֻжһ޶id");
		} else {
			sqlInfos.put(idValue, new SqlInfo(idValue,sqlTypeValue,sqlNameValue));
		}
	}

	private Document read(String filename) {
		Document document = null;	
		try {
			SAXReader reader = new SAXReader();
			document = reader.read(this.getClass().getClassLoader().getResourceAsStream(filename));
		} catch (DocumentException e) {
			System.out.println("classPathҲļsql.cfg.xml,ȡʧ");
		}		
		return document;	
	}

	public Map<String, SqlInfo> getSqlInfos() {
		return sqlInfos;
	}
}
