package com.typ.myframework.sping;

import java.beans.PropertyDescriptor;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.dom4j.Attribute;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

import com.typ.myframework.Initable;

public final class BeanXmlContextBuilder implements Initable {	
	
	private Map<String,Object> beanMap = new HashMap<String,Object>();

	public BeanXmlContextBuilder () {			
		init();		
	}
	
	//ɨxmlļ
	@Override
	public void init() {	
		//õļĸԪ
		Element root = getRootElement();	
		//õеbeanԪ
		List<Element> beans = root.elements("bean");
		//еbeanԪأװmapУkeyΪbeanidvalueΪbean
		for(Element bean : beans) {
			//beanĸʽ
			checkBeanData(bean);
			//bean
			Object beanObj =  getBeanObject(bean.attribute("class").getText());		
			//װ
			beanMap.put(bean.attributeValue("id"),beanObj);				
		}	
		//ʼע
		new XmlDiSupport(beanMap,beans).executeDi();
		//ʼ(aop)
		new XmlAopSupport(beanMap,beans).executeAop();
	}

	//beanԪصĸʽǷȷ
	private void checkBeanData(Element bean) {
		Attribute classAttr = bean.attribute("class");
		Attribute idAttr = bean.attribute("id");
		if (classAttr == null) {
			try {
				throw new BeansXmlReadException("ڵbeanclassΪ");
			} catch (BeansXmlReadException e) {
				e.printStackTrace();
			}
		}
		if (idAttr == null) {
			try {
				throw new BeansXmlReadException("ڵbeanidΪ");
			} catch (BeansXmlReadException e) {
				e.printStackTrace();
			}
		}		
	}
	
	//õbeanԪµpropertyԪ
	private Element getProperty(Element bean)  {		
	    Element property = bean.element("property");	
	    if (property == null)return null;
	    
	    //nameΪ׳쳣
		if (property.attributeValue("name") ==  null) {
			try {
				throw new BeansXmlReadException("ڵPropertynameԲΪ");
			} catch (BeansXmlReadException e) {				
				e.printStackTrace();
			}
		}
		 //refΪ׳쳣
		if (property.attributeValue("ref") == null) {
			try {
				throw new BeansXmlReadException("ڵPropertyrefԲΪ");
			} catch (BeansXmlReadException e) {
				e.printStackTrace();
			}
		}
		return property;
	}
	//ͨbean֣һ
	private Object getBeanObject(String name) {		
		Object obj = null;
		try {
			obj = (Object)Class.forName(name).newInstance();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		return obj;
	}
	//õxmlļĸڵ(beansڵ)
	private Element getRootElement() {
		SAXReader reader = new SAXReader();		
		Element root = null;
		try {
			root = reader.read(this.getClass().getClassLoader().getResourceAsStream("beans.xml"))
								 .getRootElement();		
		} catch (DocumentException e) {			
			e.printStackTrace();		
		}
		return root;
	}
	
	//¶ȡ
	@Override
	public void reload() {
		try {
			init();
		} catch (Exception e) {
			e.printStackTrace();
		}		
	}
	
	@Override
	public Map<String, Object> getMap() {	
		return beanMap;
	}
}