package com.typ.myframework.sping;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;

public class ProxyFactoryBean {
	
	private Object target;
	private Advice advice;
	
	public Object getProxy() {
		Object proxyObj = Proxy.newProxyInstance(
				target.getClass().getClassLoader(),
				target.getClass().getInterfaces(),
				new InvocationHandler(){	
					@Override
					public Object invoke(Object proxy, Method method, Object[] args)
							throws Throwable {							
						Object result = null;
						try {
							advice.beforeAndAfter(proxy, method, args);
							advice.before(proxy, method, args);							
							result = method.invoke(target, args);
							advice.after(proxy, method, args);
							advice.beforeAndAfter(proxy, method, args);
						} catch (Exception e) {
							 advice.exception(proxy, method, args);
						}
						return result;
						
					}
				});			

		return proxyObj;
}
	public Object getProxy(Object target,Advice advice) {
		this.target = target;
		this.advice = advice;
		return getProxy();
}
	public Object getTarget() {
		return target;
	}
	public void setTarget(Object target) {
		this.target = target;
	}
	public Advice getAdvice() {
		return advice;
	}
	public void setAdvice(Advice advice) {
		this.advice = advice;
	}
}
