package com.typ.myframework.sping;

import java.util.List;
import java.util.Map;
import org.dom4j.Attribute;
import org.dom4j.Element;

import com.typ.myframework.MyFrameorkException;

public class XmlAopSupport implements AopSupport {
	private Map<String,Object> beanMap;
	private List<Element> beans;
	
	public XmlAopSupport(Map<String,Object> beanMap,List<Element> beans) {
		this.beanMap = beanMap;
		this.beans = beans;
	}
	
	@Override
	public void executeAop() {
		for(Element bean : beans) {
			List<Element> aspectNodes  = bean.elements("aspect");
			//beanڵaspectԪؽڵ0Ͳ
			if (aspectNodes.size() != 0) {
				Object target = beanMap.get(bean.attributeValue("id"));
				//ɨbeanµ棨adviceõ󣬲beanMap
				for (Element aspectNode : aspectNodes) {					
					Advice advcieObj = getAdviceObj(aspectNode);	
					ProxyFactoryBean proxyFactoryBean = new ProxyFactoryBean();
					proxyFactoryBean.setTarget(target);
					proxyFactoryBean.setAdvice(advcieObj);
					target = proxyFactoryBean.getProxy();
				}
				beanMap.remove(bean.attributeValue("id"));
				beanMap.put(bean.attributeValue("id"), target);
			}
		}				
	}
	
	private Advice getAdviceObj(Element aspectNode) {
		String aspectClassName = getAspectClassName(aspectNode);
		Advice result = null;
		try {		
			result = (Advice)Class.forName(aspectClassName).newInstance();			
		} catch (Exception e) {
			try {
				throw new MyFrameorkException("Ի" + aspectClassName + "Ķʱʧ");
			} catch (MyFrameorkException e1) {
				e1.printStackTrace();
			}
		}
		return result;
	}
	
	//beanµԪaspectclassֵ
	private String getAspectClassName(Element aspectNode) {
		Attribute classAttr = aspectNode.attribute("class");
		if (classAttr == null) {
			try {
				throw new BeansXmlReadException("ڵbeanµĽڵaspectclassԲΪ");
			} catch (BeansXmlReadException e) {
				e.printStackTrace();
			}
		}
		return classAttr.getText();
	}	
}
